# This file is generated by numpy's build process
# It contains system_info results at the time of building this package.
from enum import Enum
from numpy._core._multiarray_umath import (
    __cpu_features__,
    __cpu_baseline__,
    __cpu_dispatch__,
)

__all__ = ["show"]
_built_with_meson = True


class DisplayModes(Enum):
    stdout = "stdout"
    dicts = "dicts"


def _cleanup(d):
    """
    Removes empty values in a `dict` recursively
    This ensures we remove values that Meson could not provide to CONFIG
    """
    if isinstance(d, dict):
        return {k: _cleanup(v) for k, v in d.items() if v and _cleanup(v)}
    else:
        return d


CONFIG = _cleanup(
    {
        "Compilers": {
            "c": {
                "name": "clang",
                "linker": r"ld64",
                "version": "14.0.6",
                "commands": r"x86_64-apple-darwin13.4.0-clang",
                "args": r"-march=core2, -mtune=haswell, -mssse3, -ftree-vectorize, -fPIC, -fPIE, -fstack-protector-strong, -O2, -pipe, -isystem, /var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/include, -fdebug-prefix-map=/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/work=/usr/local/src/conda/numpy-base-2.1.1, -fdebug-prefix-map=/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla=/usr/local/src/conda-prefix, -D_FORTIFY_SOURCE=2, -isystem, /var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/include, -mmacosx-version-min=10.15",
                "linker args": r"-Wl,-pie, -Wl,-headerpad_max_install_names, -Wl,-dead_strip_dylibs, -Wl,-rpath,/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/lib, -L/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/lib, -march=core2, -mtune=haswell, -mssse3, -ftree-vectorize, -fPIC, -fPIE, -fstack-protector-strong, -O2, -pipe, -isystem, /var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/include, -fdebug-prefix-map=/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/work=/usr/local/src/conda/numpy-base-2.1.1, -fdebug-prefix-map=/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla=/usr/local/src/conda-prefix, -D_FORTIFY_SOURCE=2, -isystem, /var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/include, -mmacosx-version-min=10.15",
            },
            "cython": {
                "name": "cython",
                "linker": r"cython",
                "version": "3.0.11",
                "commands": r"cython",
                "args": r"",
                "linker args": r"",
            },
            "c++": {
                "name": "clang",
                "linker": r"ld64",
                "version": "14.0.6",
                "commands": r"x86_64-apple-darwin13.4.0-clang++",
                "args": r"-march=core2, -mtune=haswell, -mssse3, -ftree-vectorize, -fPIC, -fPIE, -fstack-protector-strong, -O2, -pipe, -stdlib=libc++, -fvisibility-inlines-hidden, -fmessage-length=0, -isystem, /var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/include, -fdebug-prefix-map=/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/work=/usr/local/src/conda/numpy-base-2.1.1, -fdebug-prefix-map=/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla=/usr/local/src/conda-prefix, -D_FORTIFY_SOURCE=2, -isystem, /var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/include, -mmacosx-version-min=10.15",
                "linker args": r"-Wl,-pie, -Wl,-headerpad_max_install_names, -Wl,-dead_strip_dylibs, -Wl,-rpath,/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/lib, -L/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/lib, -march=core2, -mtune=haswell, -mssse3, -ftree-vectorize, -fPIC, -fPIE, -fstack-protector-strong, -O2, -pipe, -stdlib=libc++, -fvisibility-inlines-hidden, -fmessage-length=0, -isystem, /var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/include, -fdebug-prefix-map=/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/work=/usr/local/src/conda/numpy-base-2.1.1, -fdebug-prefix-map=/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla=/usr/local/src/conda-prefix, -D_FORTIFY_SOURCE=2, -isystem, /var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/include, -mmacosx-version-min=10.15",
            },
        },
        "Machine Information": {
            "host": {
                "cpu": "x86_64",
                "family": "x86_64",
                "endian": "little",
                "system": "darwin",
            },
            "build": {
                "cpu": "x86_64",
                "family": "x86_64",
                "endian": "little",
                "system": "darwin",
            },
            "cross-compiled": bool("False".lower().replace("false", "")),
        },
        "Build Dependencies": {
            "blas": {
                "name": "openblas",
                "found": bool("True".lower().replace("false", "")),
                "version": "0.3.21",
                "detection method": "pkgconfig",
                "include directory": r"/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/include",
                "lib directory": r"/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/lib",
                "openblas configuration": r"USE_64BITINT= DYNAMIC_ARCH=1 DYNAMIC_OLDER= NO_CBLAS= NO_LAPACK=0 NO_LAPACKE= NO_AFFINITY=1 USE_OPENMP=0 CORE2 MAX_THREADS=128",
                "pc file directory": r"/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/lib/pkgconfig",
            },
            "lapack": {
                "name": "openblas",
                "found": bool("True".lower().replace("false", "")),
                "version": "0.3.21",
                "detection method": "pkgconfig",
                "include directory": r"/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/include",
                "lib directory": r"/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/lib",
                "openblas configuration": r"USE_64BITINT= DYNAMIC_ARCH=1 DYNAMIC_OLDER= NO_CBLAS= NO_LAPACK=0 NO_LAPACKE= NO_AFFINITY=1 USE_OPENMP=0 CORE2 MAX_THREADS=128",
                "pc file directory": r"/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/lib/pkgconfig",
            },
        },
        "Python Information": {
            "path": r"/var/folders/c_/qfmhj66j0tn016nkx_th4hxm0000gp/T/abs_f1gh2c23os/croot/numpy_and_numpy_base_1728047645270/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/bin/python",
            "version": "3.12",
        },
        "SIMD Extensions": {
            "baseline": __cpu_baseline__,
            "found": [
                feature for feature in __cpu_dispatch__ if __cpu_features__[feature]
            ],
            "not found": [
                feature for feature in __cpu_dispatch__ if not __cpu_features__[feature]
            ],
        },
    }
)


def _check_pyyaml():
    import yaml

    return yaml


def show(mode=DisplayModes.stdout.value):
    """
    Show libraries and system information on which NumPy was built
    and is being used

    Parameters
    ----------
    mode : {`'stdout'`, `'dicts'`}, optional.
        Indicates how to display the config information.
        `'stdout'` prints to console, `'dicts'` returns a dictionary
        of the configuration.

    Returns
    -------
    out : {`dict`, `None`}
        If mode is `'dicts'`, a dict is returned, else None

    See Also
    --------
    get_include : Returns the directory containing NumPy C
                  header files.

    Notes
    -----
    1. The `'stdout'` mode will give more readable
       output if ``pyyaml`` is installed

    """
    if mode == DisplayModes.stdout.value:
        try:  # Non-standard library, check import
            yaml = _check_pyyaml()

            print(yaml.dump(CONFIG))
        except ModuleNotFoundError:
            import warnings
            import json

            warnings.warn("Install `pyyaml` for better output", stacklevel=1)
            print(json.dumps(CONFIG, indent=2))
    elif mode == DisplayModes.dicts.value:
        return CONFIG
    else:
        raise AttributeError(
            f"Invalid `mode`, use one of: {', '.join([e.value for e in DisplayModes])}"
        )
